﻿import es
import playerlib
import cmdlib
import gamethread
import usermsg
import cfglib

info = es.AddonInfo()
info.author = 'ShoTaXx'
info.basename = 'botreplace'
info.name = 'BotReplace'
info.description = 'Players can replace living friendly Bots.'
info.url = 'http://addons.eventscripts.com/addons/view/botreplace'
info.version = '1'
es.ServerVar('botreplace_version', info.version, info.description).makepublic()

gamename = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').rsplit('/',1)[~0]
ragdoll = {'cstrike':'cs_ragdoll', 'hl2dm':'hl2dm_ragdoll', 'tf':'tf_ragdoll', 'dod':'dod_ragdoll'}.get(gamename)
akd = es.exists('script','autokick_disabler')

def load():
    cmdlib.registerSayCommand('!r', botreplace, '')

def botreplace(userid, args):
    bot = es.getuserid(es.getplayerprop(userid, 'CBasePlayer.m_hObserverTarget'))
    if bot:
        both = playerlib.getPlayer(bot)
        if both.isbot:
            user = playerlib.getPlayer(userid)
            if user.isdead:
                if user.teamid == both.teamid:
                    bx,by,bz = both.getLocation()
                    bvx,bvy,bvz = both.getViewAngle()
                    es.server.queuecmd('es_setplayerprop %i CCSPlayer.m_iPlayerState 0' % userid)
                    es.server.queuecmd('es_setplayerprop %i CCSPlayer.baseclass.m_lifeState 512' % userid)
                    es.server.queuecmd('es_spawnplayer %i' % userid)
                    es.server.queuecmd('bot_kill %s' % both.name)
                    es.server.queuecmd('es_fire %s %s kill' % (userid, ragdoll))
                    es.server.queuecmd('es_setpos %i %i %i %i' % (userid, bx, by, bz))
                    es.server.queuecmd('es_setang %i %i %i %i' % (userid, bvx, bvy, bvz))
                    es.msg('#multi','#green[#darkgreenBotReplace#green]#default %s#lightgreen replaced#default Bot %s' % (user.name, both.name))

def player_activate(ev):
    if akd == 0:
        es.server.mp_disable_autokick(ev['userid'])
                    
def player_death(ev):
    userid = ev['userid']
    team = es.getplayerteam(userid)
    if (team == 2 and playerlib.getPlayerList('#bot,#alive,#t') != []) or (team == 3 and playerlib.getPlayerList('#bot,#alive,#ct') != []):
        gamethread.delayed(3, es.tell, (userid, '#multi', '#green[#darkgreenBotReplace#green]#lightgreen Type#default !r#lightgreen into chat to replace a friendly living Bot!'))
        gamethread.delayed(3, usermsg.hudhint, (userid,'Type !r into chat to replace a friendly living Bot!'))

def unload():
    cmdlib.unregisterSayCommand('!r')